/**********************************************************************
 * Copyright (C) 20014-2015 by Vidisolve (Pty) Ltd.                   *
 * All Rights Reserved.                                               *
 *                                                                    *
 *  Software is distributed on an "AS IS", WITHOUT WARRANTY OF ANY    *
 *   KIND, either express or implied.                                 *
 *                                                                    *
 *  Contributors:                                                     *
 *                                                                    *
 **********************************************************************/
/*------------------------------------------------------------------------
    File        : Example1.p
    Purpose     : 

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Sun May 31 20:34:55 CAT 2015
    Notes       :
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

BLOCK-LEVEL ON ERROR UNDO, THROW.

DEFINE VARIABLE vDate AS DATE NO-UNDO.

/* ***************************  Main Block  *************************** */

block1a:
FOR EACH glTransaction NO-LOCK /* transactionType - Rule 3 */
    WHERE glTransaction.transactionType  = "INV"
      AND gltransaction.transactionDate >= 05/01/2015
      AND gltransaction.transactionDate <= 05/31/2015:

END.

block1b:
FOR EACH glTransaction NO-LOCK /* transactionType - Rule 3 &  transactionDate - Rule 4 */
    WHERE glTransaction.transactionType  = "INV"
       OR gltransaction.transactionDate >= 05/01/2015
      AND gltransaction.transactionDate <= 05/31/2015:

END.

block2a:
DO vDate = 05/01/2015 TO 05/31/2015:  /* Two indexes combine */
    FOR EACH glTransaction NO-LOCK /* transactionType & transactionDate - Rule 3 x2 */
        WHERE glTransaction.transactionType  = "INV"
          AND gltransaction.transactionDate  = vDate:
    
    END.
END.

FIND LAST glTransaction NO-LOCK 
    WHERE glTransaction.transactionType  = "INV"
      AND gltransaction.transactionDate  = TODAY
    NO-ERROR.

block2b:
DO vDate = 05/01/2015 TO 05/31/2015: /* The sequence does not matter, same as before */
    FOR EACH glTransaction NO-LOCK /* transactionDate & transactionType - Rule 3 x2 */
        WHERE gltransaction.transactionDate  = vDate
          AND glTransaction.transactionType  = "INV":
    
    END.
END.


block3a: 
FOR EACH glrTransaction NO-LOCK /* transactionType - Rule 3 */
    WHERE glrTransaction.transactionType  = "INV"
      AND glrtransaction.transactionDate >= 05/01/2015
      AND glrtransaction.transactionDate <= 05/31/2015:

END.

block3b: 
FOR EACH glrTransaction NO-LOCK /* transactionType - Prime directive */
    WHERE glrTransaction.transactionType  = "INV"
      AND glrtransaction.transactionDate >= 05/01/2015
      AND glrtransaction.transactionDate <= 05/31/2015
    USE-INDEX transactionType:

END.

block4: /* Now we have two identical indexes, but in different orders. Combining them */
        /* wins us nothing, so rule 6 is used to eliminate the redundant index.       */
DO vDate = 05/01/2015 TO 05/31/2015:
    FOR EACH glrTransaction NO-LOCK /* transactionDate - Rule 3 & Rule 6 */
        WHERE glrTransaction.transactionType  = "INV"
          AND glrtransaction.transactionDate  = vDate:
    
    END.
END.

block10a:
FOR EACH glrTransaction NO-LOCK /* transactionDate! - Rule 4 - 1 Bracket over date range */
    WHERE (glrTransaction.transactionType = "INV" OR
           glrTransaction.transactionType = "CRN")
      AND glrTransaction.transactionDate >= 05/01/2015
      AND glrTransaction.transactionDate <= 05/31/2015:

END.

block10b:
FOR EACH glrTransaction NO-LOCK /* transactionType & transactionType - Rule 4 - 2 Brackets*/
    WHERE glrTransaction.transactionType = "INV" 
      AND glrTransaction.transactionDate >= 05/01/2015
      AND glrTransaction.transactionDate <= 05/31/2015
        OR glrTransaction.transactionType = "CRN"
      AND glrTransaction.transactionDate >= 05/01/2015
      AND glrTransaction.transactionDate <= 05/31/2015:

END.

block10c:
FOR EACH glrTransaction NO-LOCK /* transactionType - WHOLE-INDEX - Prime Directive */
    WHERE glrTransaction.transactionType = "INV"
      AND glrTransaction.transactionDate >= 05/01/2015
      AND glrTransaction.transactionDate <= 05/31/2015
        OR glrTransaction.transactionType = "CRN"
      AND glrTransaction.transactionDate >= 05/01/2015
      AND glrTransaction.transactionDate <= 05/31/2015
    USE-INDEX transactionType :

END.

block5a1:
FOR EACH gldTransaction NO-LOCK /* typeDocNo - Rule 3 */
    WHERE gldTransaction.transactionType  = "INV"
      AND gldtransaction.transactionDate >= 05/01/2015
      AND gldtransaction.transactionDate <= 05/31/2015:

END.

block5a2:                            /* transactionDate - Rule 3 */
DO vDate = 05/01/2015 TO 05/31/2015: /* This one is essentially the same as case 2 */
    FOR EACH gldTransaction NO-LOCK  /* but we are not using the full typeDocNo, so it DOES NOT COMBINE! */
        WHERE gldTransaction.transactionType  = "INV"
          AND gldtransaction.transactionDate  = vDate:
    
    END.
END.

block5a3:                            /* transactionDate - Rule 3 & typeDocNo - Rule 3 */
DO vDate = 05/01/2015 TO 05/31/2015: /* This one is essentially the same as case 2 */
    FOR EACH gldTransaction NO-LOCK  /* */
        WHERE gldTransaction.transactionType  = "INV"
          AND gldtransaction.documentNo       = "I23001214"
          AND gldtransaction.transactionDate  = vDate:
    
    END.
END.

block5a4:                            /* typeDocNo - Rule 3 & transactionDate - Rule 4 */
DO vDate = 05/01/2015 TO 05/31/2015: /* The OR use 2 brackets to satisfy two options */
    FOR EACH gldTransaction NO-LOCK  /*   */
        WHERE gldTransaction.transactionType  = "INV"
           OR gldtransaction.transactionDate  > 05/01/2015:
    
    END.
END.

FIND FIRST gldTransaction NO-LOCK  /* transactionID - Rule 7, WHOLE-INDEX  */
    WHERE gldTransaction.transactionType  = "INV"
       OR gldtransaction.transactionDate  > 05/01/2015
    NO-ERROR.
           
block5b1:
FOR EACH gldTransaction NO-LOCK /* transactionID - Rule 7 - WHOLE-INDEX */
    WHERE gldtransaction.documentNo      = "I23001214":

END.

block5b2:                       /* typeDocNo - Rule 4 - No WHOLE-INDEX, but the bracket is WHOLE-INDEX */
FOR EACH gldTransaction NO-LOCK /* In fact, we made it worse, as the index is larger on disk           */
    WHERE gldTransaction.transactionType > ""
      AND gldtransaction.documentNo      = "I23001214":

END.

block5c:
FOR EACH gldTransaction NO-LOCK /* transactionDate - Rule 4 DB can only eveluate */
                                /* the CAN-DO() after the record was retrieved.  */
    WHERE CAN-DO(gldTransaction.transactionType,"INV,CRN")  
      AND gldtransaction.transactionDate >= 05/01/2015
      AND gldtransaction.transactionDate <= 05/31/2015:

END.

block5d:
FOR EACH gldTransaction NO-LOCK /* transactionDate! - Rule 4 - 1 Bracket over date range */
    WHERE (gldTransaction.transactionType = "INV" OR
           gldTransaction.transactionType = "CRN")
      AND gldtransaction.transactionDate >= 05/01/2015
      AND gldtransaction.transactionDate <= 05/01/2015:

END.

block5e:
FOR EACH gldTransaction NO-LOCK /* typeDate & typeDate - Rule 4 - 2 Brackets*/
    WHERE gldTransaction.transactionType = "INV" 
      AND gldtransaction.transactionDate >= 05/01/2015
      AND gldtransaction.transactionDate <= 05/31/2015
        OR gldTransaction.transactionType = "CRN"
      AND gldtransaction.transactionDate >= 05/01/2015
      AND gldtransaction.transactionDate <= 05/31/2015:

END.

block6:
DO vDate = 05/01/2015 TO 05/31/2015:
    FOR EACH gldTransaction NO-LOCK  /* transactionDate Rule 3 - This WILL NOT force selection of typeDate! */ 
        WHERE gldTransaction.transactionType  > ""
          AND gldtransaction.transactionDate  = vDate:
    
    END.
END.

block7:
FOR EACH genTransaction NO-LOCK /* typeDate - Rule 3 */
    WHERE genTransaction.transactionType  = "INV"
      AND genTransaction.transactionDate >= 05/01/2015
      AND genTransaction.transactionDate <= 05/31/2015:

END.

block8:
DO vDate = 05/01/2015 TO 05/31/2015:
    FOR EACH genTransaction NO-LOCK  /* transactionID - WHOLE-INDEX Rule 7 */ 
        WHERE genTransaction.transactionDate  = vDate:
    
    END.
END.

block9:                               
DO vDate = 05/01/2015 TO 05/31/2015:  /* DateType Rule 4 - Note the absense of */           
    FOR EACH genTransaction NO-LOCK   /*WHOLE-INDEX, yet it does use the whole index.... */ 
        WHERE genTransaction.transactionType  > ""
          AND genTransaction.transactionDate  = vDate:
    
    END.
END.


